(ns wanijo.visualisation.routes
  (:require [compojure.core :refer [defroutes wrap-routes
                                    GET POST DELETE]]
            [ring.util.response :as resp]
            [wanijo.framework.routing :refer [register! path]]
            [wanijo.framework.view :as view]
            [wanijo.instance.domain :as domain-instance]
            [wanijo.visualisation.domain :as vis-domain]
            [wanijo.visualisation.viz :as viz]))

(defn all-instances [req]
  (view/layout!
   :request req
   :content
   [[:h1 "All Instances"]
    (viz/all-instances (vis-domain/all-instance-connections!))]))

(defroutes routes
  (GET (register! :vis-single-instance "/visualisation/instance/:uuid")
       [uuid]
       {:body (viz/single-instance
               (domain-instance/full-instance-by-uuid! uuid))
        :headers {"Content-Type" "image/svg+xml"}})
  (GET (register! :vis-all-instances "/visualisation/all-instances")
       [:as req]
       (all-instances req)))
